=== packaging/debian/changelog ===
flameshot (13.0.0-1) unstable; urgency=medium

  * Release for v13

 -- Jeremy Borgman <borgman.jeremy@pm.me>  Sun, 03 Aug 2025 18:24:29 -0600
