=== packaging/debian/control ===
Source: flameshot
Section: graphics
Priority: optional
Maintainer: Boyuan Yang <byang@debian.org>
Build-Depends:
 cmake (>= 3.13~),
 debhelper (>= 11),
 qt6-base-dev (>= 6.2.0~),
 qt6-tools-dev (>= 6.2.0~),
 qt6-tools-dev-tools (>= 6.2.0~),
 qt6-svg-dev (>= 6.2.0~) | libqt6svg6-dev (>= 6.2.0~),
 qt6-l10n-tools,
 libgl-dev,
Standards-Version: 4.5.0
Homepage: https://github.com/flameshot-org/flameshot
Vcs-Browser: https://github.com/flameshot-org/flameshot
Vcs-Git: https://github.com/flameshot-org/flameshot.git

Package: flameshot
Architecture: any
Depends:
 hicolor-icon-theme,
 libqt6svg6 (>= 6.2.0~),
 qt6-qpa-plugins (>= 6.2.0~),
 ${shlibs:Depends},
 ${misc:Depends},
Recommends:
 xdg-desktop-portal-gtk | xdg-desktop-portal-gnome | xdg-desktop-portal-kde | xdg-desktop-portal-wlr,
 grim,
Suggests:
 ca-certificates,
 openssl,
 qt6-image-formats-plugins,
Description: Powerful yet simple-to-use screenshot software
 Flameshot is a powerful yet simple-to-use screenshot software.
 Notable features include customizable appearance, in-app screenshot editing,
 D-Bus interface, experimental GNOME/KDE Wayland support, integration with
 Imgur and support for both GUI and CLI interface.
